import{S as oa,i as sa,s as ra,e as r,k as u,w as Kt,t as o,M as ia,c as i,d as t,m as h,a as p,x as Vt,h as s,b as c,N as ne,G as a,g as l,y as Xt,L as na,q as Zt,o as ea,B as ta,v as la}from"../../chunks/vendor-hf-doc-builder.js";import{I as aa}from"../../chunks/IconCopyLink-hf-doc-builder.js";function pa(kt){let d,le,_,E,j,Q,xe,C,De,pe,P,Et,ce,f,Re,H,$e,Oe,U,We,Ie,ue,m,Ae,z,qe,Be,F,Me,je,he,y,N,Y,S,Ce,J,He,fe,g,Ue,K,ze,Fe,V,Ye,Je,me,w,Ke,X,Ve,Xe,Z,Ze,et,ge,T,tt,ee,at,ot,we,G,Nt,ve,k,te,st,rt,ae,it,nt,de,L,Tt,_e,b,lt,oe,pt,ct,ye,x,bt,ke,v,ut,se,ht,ft,re,mt,gt,Ee,D,wt,R,vt,Ne,O,dt,Te,$,Qt,be,W,_t,Qe;return Q=new aa({}),S=new aa({}),{c(){d=r("meta"),le=u(),_=r("h1"),E=r("a"),j=r("span"),Kt(Q.$$.fragment),xe=u(),C=r("span"),De=o("The Deep Q-Network (DQN)"),pe=o(`

This is the architecture of our Deep Q-Learning network:
`),P=r("img"),ce=u(),f=r("p"),Re=o("As input, we take a "),H=r("strong"),$e=o("stack of 4 frames"),Oe=o(" passed through the network as a state and output a "),U=r("strong"),We=o("vector of Q-values for each possible action at that state"),Ie=o(". Then, like with Q-Learning, we just need to use our epsilon-greedy policy to select which action to take."),ue=u(),m=r("p"),Ae=o("When the Neural Network is initialized, "),z=r("strong"),qe=o("the Q-value estimation is terrible"),Be=o(". But during training, our Deep Q-Network agent will associate a situation with appropriate action and "),F=r("strong"),Me=o("learn to play the game well"),je=o("."),he=u(),y=r("h2"),N=r("a"),Y=r("span"),Kt(S.$$.fragment),Ce=u(),J=r("span"),He=o("Preprocessing the input and temporal limitation"),fe=u(),g=r("p"),Ue=o("We need to "),K=r("strong"),ze=o("preprocess the input"),Fe=o(". It\u2019s an essential step since we want to "),V=r("strong"),Ye=o("reduce the complexity of our state to reduce the computation time needed for training"),Je=o("."),me=u(),w=r("p"),Ke=o("To achieve this, we "),X=r("strong"),Ve=o("reduce the state space to 84x84 and grayscale it"),Xe=o(`. We can do this since the colors in Atari environments don\u2019t add important information.
This is an essential saving since we `),Z=r("strong"),Ze=o("reduce our three color channels (RGB) to 1"),et=o("."),ge=u(),T=r("p"),tt=o("We can also "),ee=r("strong"),at=o("crop a part of the screen in some games"),ot=o(` if it does not contain important information.
Then we stack four frames together.`),we=u(),G=r("img"),ve=u(),k=r("p"),te=r("strong"),st=o("Why do we stack four frames together?"),rt=o(`
We stack frames together because it helps us `),ae=r("strong"),it=o("handle the problem of temporal limitation"),nt=o(". Let\u2019s take an example with the game of Pong. When you see this frame:"),de=u(),L=r("img"),_e=u(),b=r("p"),lt=o(`Can you tell me where the ball is going?
No, because one frame is not enough to have a sense of motion! But what if I add three more frames? `),oe=r("strong"),pt=o("Here you can see that the ball is going to the right"),ct=o("."),ye=u(),x=r("img"),ke=o(`
That\u2019s why, to capture temporal information, we stack four frames together.
`),v=r("p"),ut=o("Then, the stacked frames are processed by three convolutional layers. These layers "),se=r("strong"),ht=o("allow us to capture and exploit spatial relationships in images"),ft=o(". But also, because frames are stacked together, "),re=r("strong"),mt=o("you can exploit some spatial properties across those frames"),gt=o("."),Ee=u(),D=r("p"),wt=o("If you don\u2019t know what are convolutional layers, don\u2019t worry. You can check the "),R=r("a"),vt=o("Lesson 4 of this free Deep Reinforcement Learning Course by Udacity"),Ne=u(),O=r("p"),dt=o("Finally, we have a couple of fully connected layers that output a Q-value for each possible action at that state."),Te=u(),$=r("img"),be=u(),W=r("p"),_t=o("So, we see that Deep Q-Learning is using a neural network to approximate, given a state, the different Q-values for each possible action at that state. Let\u2019s now study the Deep Q-Learning algorithm."),this.h()},l(e){const n=ia('[data-svelte="svelte-1phssyn"]',document.head);d=i(n,"META",{name:!0,content:!0}),n.forEach(t),le=h(e),_=i(e,"H1",{class:!0});var Pe=p(_);E=i(Pe,"A",{id:!0,class:!0,href:!0});var Pt=p(E);j=i(Pt,"SPAN",{});var St=p(j);Vt(Q.$$.fragment,St),St.forEach(t),Pt.forEach(t),xe=h(Pe),C=i(Pe,"SPAN",{});var Gt=p(C);De=s(Gt,"The Deep Q-Network (DQN)"),Gt.forEach(t),Pe.forEach(t),pe=s(e,`

This is the architecture of our Deep Q-Learning network:
`),P=i(e,"IMG",{src:!0,alt:!0}),ce=h(e),f=i(e,"P",{});var I=p(f);Re=s(I,"As input, we take a "),H=i(I,"STRONG",{});var Lt=p(H);$e=s(Lt,"stack of 4 frames"),Lt.forEach(t),Oe=s(I," passed through the network as a state and output a "),U=i(I,"STRONG",{});var xt=p(U);We=s(xt,"vector of Q-values for each possible action at that state"),xt.forEach(t),Ie=s(I,". Then, like with Q-Learning, we just need to use our epsilon-greedy policy to select which action to take."),I.forEach(t),ue=h(e),m=i(e,"P",{});var A=p(m);Ae=s(A,"When the Neural Network is initialized, "),z=i(A,"STRONG",{});var Dt=p(z);qe=s(Dt,"the Q-value estimation is terrible"),Dt.forEach(t),Be=s(A,". But during training, our Deep Q-Network agent will associate a situation with appropriate action and "),F=i(A,"STRONG",{});var Rt=p(F);Me=s(Rt,"learn to play the game well"),Rt.forEach(t),je=s(A,"."),A.forEach(t),he=h(e),y=i(e,"H2",{class:!0});var Se=p(y);N=i(Se,"A",{id:!0,class:!0,href:!0});var $t=p(N);Y=i($t,"SPAN",{});var Ot=p(Y);Vt(S.$$.fragment,Ot),Ot.forEach(t),$t.forEach(t),Ce=h(Se),J=i(Se,"SPAN",{});var Wt=p(J);He=s(Wt,"Preprocessing the input and temporal limitation"),Wt.forEach(t),Se.forEach(t),fe=h(e),g=i(e,"P",{});var q=p(g);Ue=s(q,"We need to "),K=i(q,"STRONG",{});var It=p(K);ze=s(It,"preprocess the input"),It.forEach(t),Fe=s(q,". It\u2019s an essential step since we want to "),V=i(q,"STRONG",{});var At=p(V);Ye=s(At,"reduce the complexity of our state to reduce the computation time needed for training"),At.forEach(t),Je=s(q,"."),q.forEach(t),me=h(e),w=i(e,"P",{});var B=p(w);Ke=s(B,"To achieve this, we "),X=i(B,"STRONG",{});var qt=p(X);Ve=s(qt,"reduce the state space to 84x84 and grayscale it"),qt.forEach(t),Xe=s(B,`. We can do this since the colors in Atari environments don\u2019t add important information.
This is an essential saving since we `),Z=i(B,"STRONG",{});var Bt=p(Z);Ze=s(Bt,"reduce our three color channels (RGB) to 1"),Bt.forEach(t),et=s(B,"."),B.forEach(t),ge=h(e),T=i(e,"P",{});var Ge=p(T);tt=s(Ge,"We can also "),ee=i(Ge,"STRONG",{});var Mt=p(ee);at=s(Mt,"crop a part of the screen in some games"),Mt.forEach(t),ot=s(Ge,` if it does not contain important information.
Then we stack four frames together.`),Ge.forEach(t),we=h(e),G=i(e,"IMG",{src:!0,alt:!0}),ve=h(e),k=i(e,"P",{});var ie=p(k);te=i(ie,"STRONG",{});var jt=p(te);st=s(jt,"Why do we stack four frames together?"),jt.forEach(t),rt=s(ie,`
We stack frames together because it helps us `),ae=i(ie,"STRONG",{});var Ct=p(ae);it=s(Ct,"handle the problem of temporal limitation"),Ct.forEach(t),nt=s(ie,". Let\u2019s take an example with the game of Pong. When you see this frame:"),ie.forEach(t),de=h(e),L=i(e,"IMG",{src:!0,alt:!0}),_e=h(e),b=i(e,"P",{});var Le=p(b);lt=s(Le,`Can you tell me where the ball is going?
No, because one frame is not enough to have a sense of motion! But what if I add three more frames? `),oe=i(Le,"STRONG",{});var Ht=p(oe);pt=s(Ht,"Here you can see that the ball is going to the right"),Ht.forEach(t),ct=s(Le,"."),Le.forEach(t),ye=h(e),x=i(e,"IMG",{src:!0,alt:!0}),ke=s(e,`
That\u2019s why, to capture temporal information, we stack four frames together.
`),v=i(e,"P",{});var M=p(v);ut=s(M,"Then, the stacked frames are processed by three convolutional layers. These layers "),se=i(M,"STRONG",{});var Ut=p(se);ht=s(Ut,"allow us to capture and exploit spatial relationships in images"),Ut.forEach(t),ft=s(M,". But also, because frames are stacked together, "),re=i(M,"STRONG",{});var zt=p(re);mt=s(zt,"you can exploit some spatial properties across those frames"),zt.forEach(t),gt=s(M,"."),M.forEach(t),Ee=h(e),D=i(e,"P",{});var yt=p(D);wt=s(yt,"If you don\u2019t know what are convolutional layers, don\u2019t worry. You can check the "),R=i(yt,"A",{href:!0,rel:!0});var Ft=p(R);vt=s(Ft,"Lesson 4 of this free Deep Reinforcement Learning Course by Udacity"),Ft.forEach(t),yt.forEach(t),Ne=h(e),O=i(e,"P",{});var Yt=p(O);dt=s(Yt,"Finally, we have a couple of fully connected layers that output a Q-value for each possible action at that state."),Yt.forEach(t),Te=h(e),$=i(e,"IMG",{src:!0,alt:!0}),be=h(e),W=i(e,"P",{});var Jt=p(W);_t=s(Jt,"So, we see that Deep Q-Learning is using a neural network to approximate, given a state, the different Q-values for each possible action at that state. Let\u2019s now study the Deep Q-Learning algorithm."),Jt.forEach(t),this.h()},h(){c(d,"name","hf:doc:metadata"),c(d,"content",JSON.stringify(ca)),c(E,"id","deep-q-network"),c(E,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(E,"href","#deep-q-network"),c(_,"class","relative group"),ne(P.src,Et="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit4/deep-q-network.jpg")||c(P,"src",Et),c(P,"alt","Deep Q Network"),c(N,"id","preprocessing"),c(N,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(N,"href","#preprocessing"),c(y,"class","relative group"),ne(G.src,Nt="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit4/preprocessing.jpg")||c(G,"src",Nt),c(G,"alt","Preprocessing"),ne(L.src,Tt="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit4/temporal-limitation.jpg")||c(L,"src",Tt),c(L,"alt","Temporal Limitation"),ne(x.src,bt="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit4/temporal-limitation-2.jpg")||c(x,"src",bt),c(x,"alt","Temporal Limitation"),c(R,"href","https://www.udacity.com/course/deep-learning-pytorch--ud188"),c(R,"rel","nofollow"),ne($.src,Qt="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit4/deep-q-network.jpg")||c($,"src",Qt),c($,"alt","Deep Q Network")},m(e,n){a(document.head,d),l(e,le,n),l(e,_,n),a(_,E),a(E,j),Xt(Q,j,null),a(_,xe),a(_,C),a(C,De),l(e,pe,n),l(e,P,n),l(e,ce,n),l(e,f,n),a(f,Re),a(f,H),a(H,$e),a(f,Oe),a(f,U),a(U,We),a(f,Ie),l(e,ue,n),l(e,m,n),a(m,Ae),a(m,z),a(z,qe),a(m,Be),a(m,F),a(F,Me),a(m,je),l(e,he,n),l(e,y,n),a(y,N),a(N,Y),Xt(S,Y,null),a(y,Ce),a(y,J),a(J,He),l(e,fe,n),l(e,g,n),a(g,Ue),a(g,K),a(K,ze),a(g,Fe),a(g,V),a(V,Ye),a(g,Je),l(e,me,n),l(e,w,n),a(w,Ke),a(w,X),a(X,Ve),a(w,Xe),a(w,Z),a(Z,Ze),a(w,et),l(e,ge,n),l(e,T,n),a(T,tt),a(T,ee),a(ee,at),a(T,ot),l(e,we,n),l(e,G,n),l(e,ve,n),l(e,k,n),a(k,te),a(te,st),a(k,rt),a(k,ae),a(ae,it),a(k,nt),l(e,de,n),l(e,L,n),l(e,_e,n),l(e,b,n),a(b,lt),a(b,oe),a(oe,pt),a(b,ct),l(e,ye,n),l(e,x,n),l(e,ke,n),l(e,v,n),a(v,ut),a(v,se),a(se,ht),a(v,ft),a(v,re),a(re,mt),a(v,gt),l(e,Ee,n),l(e,D,n),a(D,wt),a(D,R),a(R,vt),l(e,Ne,n),l(e,O,n),a(O,dt),l(e,Te,n),l(e,$,n),l(e,be,n),l(e,W,n),a(W,_t),Qe=!0},p:na,i(e){Qe||(Zt(Q.$$.fragment,e),Zt(S.$$.fragment,e),Qe=!0)},o(e){ea(Q.$$.fragment,e),ea(S.$$.fragment,e),Qe=!1},d(e){t(d),e&&t(le),e&&t(_),ta(Q),e&&t(pe),e&&t(P),e&&t(ce),e&&t(f),e&&t(ue),e&&t(m),e&&t(he),e&&t(y),ta(S),e&&t(fe),e&&t(g),e&&t(me),e&&t(w),e&&t(ge),e&&t(T),e&&t(we),e&&t(G),e&&t(ve),e&&t(k),e&&t(de),e&&t(L),e&&t(_e),e&&t(b),e&&t(ye),e&&t(x),e&&t(ke),e&&t(v),e&&t(Ee),e&&t(D),e&&t(Ne),e&&t(O),e&&t(Te),e&&t($),e&&t(be),e&&t(W)}}}const ca={local:"deep-q-network",sections:[{local:"preprocessing",title:"Preprocessing the input and temporal limitation "}],title:"The Deep Q-Network (DQN)  "};function ua(kt){return la(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class ma extends oa{constructor(d){super();sa(this,d,ua,pa,ra,{})}}export{ma as default,ca as metadata};
